using System;
using System.Diagnostics;
using System.IO;

namespace xmspam
{
	/// <summary>
	/// xmspam: SpamAssassin filter for XMail written in C# - Jean-François Hovinne - http://www.hovinne.com/
	/// </summary>
	class MainClass
	{
		/// <summary>
		/// Main
		/// </summary>
		[STAThread]
		static int Main(string[] args)
		{
			//msg file
			string fpath=args[0];

			string line="";
			string header="";
			string ret="";

			bool bdata=false;

			//we call spamc
			//we redirect stdin and stdout
			Process proc=new Process();
			proc.StartInfo.FileName=args[1];
			proc.StartInfo.UseShellExecute=false;
			proc.StartInfo.RedirectStandardInput=true;
			proc.StartInfo.RedirectStandardOutput=true;
			proc.Start();

			using(StreamWriter sw=proc.StandardInput)
			{
				//we read the msg...
				using(StreamReader sr=new StreamReader(fpath))
				{
					while((line=sr.ReadLine())!=null)
					{
						if(!bdata)
						{
							header+=line+"\r\n";
						}
						else
						{
							//...and pass it to spamc
							sw.WriteLine(line);
						}
						if(line.StartsWith("<<MAIL-DATA>>"))bdata=true;
					}
					sr.Close();
				}
				sw.Close();
			}

			//stdout
			ret=proc.StandardOutput.ReadToEnd();

			proc.WaitForExit();
			proc.Close();

			//overwrite the msg
			using(StreamWriter sw=new StreamWriter(fpath))
			{
				sw.Write(header);
				sw.Write(ret);
				sw.Close();
			}

			//we return 7 to XMail
			return(7);
		}
	}
}
